/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright (c) 2010-2011 Oracle and/or its affiliates. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License("CDDL") (collectively, the "License").  You
 * may not use this file except in compliance with the License.  You can
 * obtain a copy of the License at
 * http://glassfish.java.net/public/CDDL+GPL_1_1.html
 * or packager/legal/LICENSE.txt.  See the License for the specific
 * language governing permissions and limitations under the License.
 *
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at packager/legal/LICENSE.txt.
 *
 * GPL Classpath Exception:
 * Oracle designates this particular file as subject to the "Classpath"
 * exception as provided by Oracle in the GPL Version 2 section of the License
 * file that accompanied this code.
 *
 * Modifications:
 * If applicable, add the following below the License Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyright [year] [name of copyright owner]"
 *
 * Contributor(s):
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright
 * holder.
 */

package com.sun.jersey.samples.jersey_cdi.resources;

import com.sun.jersey.samples.jersey_cdi.resources.inherited.BaseResource;
import com.sun.jersey.samples.jersey_cdi.resources.inherited.ResourceA;
import com.sun.jersey.samples.jersey_cdi.resources.inherited.ResourceB;
import com.sun.jersey.samples.jersey_cdi.resources.inherited.ResourceC;
import java.util.HashSet;
import java.util.Set;
import javax.ws.rs.core.Application;

/**
 *
 * @author Jonathan Benoit
 */
public class MyApplication extends Application {
    @Override
    public Set<Class<?>> getClasses() {
        final Set<Class<?>> classes = new HashSet<Class<?>>();
        // register root resource
        classes.add(MySimpleResource.class);
        classes.add(MyOtherResource.class);
        classes.add(JDCIBeanException.class);
        classes.add(JDCIBeanDependentException.class);
        classes.add(JCDIBeanSingletonResource.class);
        classes.add(JCDIBeanPerRequestResource.class);
        classes.add(JCDIBeanExceptionMapper.class);
        classes.add(JCDIBeanDependentSingletonResource.class);
        classes.add(JCDIBeanDependentPerRequestResource.class);
        classes.add(JCDIBeanDependentExceptionMapper.class);
        classes.add(HelloWorldResource.class);
        classes.add(FormResource.class);
        classes.add(FormBean.class);
        classes.add(EchoParamResource.class);
        classes.add(EchoParamFieldResource.class);
        classes.add(EchoParamConstructorResource.class);
        classes.add(EJBStatelessSessionBeanResource.class);
        classes.add(BaseResource.class);
        classes.add(ResourceA.class);
        classes.add(ResourceB.class);
        classes.add(ResourceC.class);        
        return classes;
    }
}